using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Matrix2DRotation
{
    public partial class Form1 : Form
    {
        double[] p1 = { 0, 50 };
        double[] p2 = { 0, -50 };
        
        public Form1()
        {
            InitializeComponent();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Interval = 50;
            if (timer1.Enabled)
            {
                timer1.Enabled = false;
                button1.Text = "Start";
            }
            else
            {
                timer1.Enabled = true;
                button1.Text = "Stop";
            }
           
        }

        private void paintLine()
        {
            // calculate centre of image - this is used as the origin (0, 0)
            double xo = pictureBox1.Width / 2;
            double yo = pictureBox1.Height / 2;

            Graphics myG = pictureBox1.CreateGraphics();
            Pen myDP = new Pen(Color.Black);        // drawing pen
            Pen myCP = new Pen(Color.LightGray);    // clearing pen

            myDP.Width = 1;
            myCP.Width = 1;

            // clear previous line
            myG.DrawLine(myCP, (float)(p1[0] + xo), (float)(p1[1] + yo), (float)(p2[0] + xo), (float)(p2[1] + yo));

            // transform line co-ordinates
            rotateLine2D(ref p1, ref p2, -5.0);

            // draw rotated line
            myG.DrawLine(myDP, (float)(p1[0] + xo), (float)(p1[1] + yo), (float)(p2[0] + xo), (float)(p2[1] + yo));

        }

        private void rotateLine2D(ref double[] pA, ref double[] pB, double angle)
        {
            // Rotate a line in 2D by the angle specified in
            // degrees

            // Warning!  The parameters are modified!


            // temp x, y storage
            double x, y;

            // convert angle from degrees to radians
            double angleRadians = (angle * Math.PI / 180.0);
            
            // pre-calculate sin and cos for given rotation angle
            double cos = Math.Cos(angleRadians);
            double sin = Math.Sin(angleRadians);

            // simplified matrix multiplication
            x = pA[0] * cos + pA[1] * sin;
            y = -pA[0] * sin + pA[1] * cos;
            
            // copy new values through parameters
            pA[0] = x;
            pA[1] = y;

            // simplified matrix multiplication
            x = pB[0] * cos + pB[1] * sin;
            y = -pB[0] * sin + pB[1] * cos;
            
            // copy new values through parameters
            pB[0] = x;
            pB[1] = y;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // paint a new line on timer tick
            paintLine();
        }

    }
}